package contrabase;

import java.io.Serializable;

/**
 * ObjectContainer 클래스의 각각의 Field 를 담는 클래스.
 * @author Jong10
 */
public class ObjectContainerField implements Serializable {
	private static final long serialVersionUID = 1L;
	
	private String fieldName;
	private String typeName;
	private Serializable value;
	
	/**
	 * 해당 객체의 값을 보관하는 용도의 필드 오브젝트.
	 * 
	 * ex)
	 * int age = 10;
	 * new ObjectContainerField("age", "int", 10);
	 * 
	 * @param fieldName 필드(멤버 변수) 이름
	 * @param typeName 타입 이름
	 * @param value 값(Serialize 가능한 Object)
	 */
	public ObjectContainerField(String fieldName, String typeName, Serializable value) {
		this.fieldName = fieldName;
		this.typeName = typeName;
		this.value = value;
	}
	
	public String getFieldName() {
		return fieldName;
	}
	
	public String getTypeName() {
		return typeName;
	}
	
	public Serializable getValue() {
		return value;
	}
}
