package contrabase.api;

import java.io.Serializable;
/**
 * RepositoryInfo 접속한 Repository 에 대한 정보가 있는 클래스
 * rid : repositoryId, 
 * IP, 
 * port, 
 * Channel : MultiUser환경에서 User 를 구분하기 위한 수단. 
 * */
public class RepositoryInfo implements Serializable {
	private static final long serialVersionUID = 1L;
	
	private String rid;
	private String ip;
	private int port;
	private String channel;
	
	public String getRid() {
		return rid;
	}

	public String getIp() {
		return ip;
	}
	
	public int getPort() {
		return port;
	}
	
	public String getChannel() {
		return channel;
	}
	
	public RepositoryInfo(String rid, String ip, int port, String channel) {
		this.rid = rid;
		this.ip = ip;
		this.port = port;
		this.channel = channel;
	}
}
