package contrabase.condition;

import java.util.SortedSet;
import java.util.TreeSet;

final public class And extends LogicalCondition {
	private static final long serialVersionUID = 1L;

	And(Condition left, Condition right) {
		super(left, right, "AND");
	}

	/**
	 * 교집합을 돌려준다.
	 */
	public SortedSet<String> getKeys(KeySelector keySelector) {
		SortedSet<String> keys = new TreeSet<String>();
		
		SortedSet<String> left = getLeft().getKeys(keySelector);
		SortedSet<String> right = getRight().getKeys(keySelector);
		
		// TODO : 이 부분은 contains 를 사용하지 않고, 개선할 수 있다. (정렬되었으므로)
		// 현재 O(N^2) 인데, O(N) 으로 수정 가능하다.
		for (String key : left) {
			if (right.contains(key))
				keys.add(key);
		}
		
		return keys;
	}
}
