package contrabase.condition;

import contrabase.condition.Term.TYPE;

public class ConditionFactory {

	public static And AND(Condition left, Condition right) {
		return new And(left, right);
	}

	public static Or OR(Condition left, Condition right) {
		return new Or(left, right);
	}

	///////////////////////////////////////////////////////////////////////////
	// TEXT 타입 생성자

	public static Term TERM(String field, String condition, String value) {
		return new Term(field, condition, value, TYPE.TEXT);
	}

	public static Term TERM(String field, String condition, char value) {
		return new Term(field, condition, Character.toString(value), TYPE.TEXT);
	}


	///////////////////////////////////////////////////////////////////////////
	// NUMBER 타입 생성자

	public static Term TERM(String field, String condition, byte value) {
		return new Term(field, condition, Byte.toString(value), TYPE.NUMBER);
	}

	public static Term TERM(String field, String condition, short value) {
		return new Term(field, condition, Short.toString(value), TYPE.NUMBER);
	}

	public static Term TERM(String field, String condition, int value) {
		return new Term(field, condition, Integer.toString(value), TYPE.NUMBER);
	}

	public static Term TERM(String field, String condition, long value) {
		return new Term(field, condition, Long.toString(value), TYPE.NUMBER);
	}

	public static Term TERM(String field, String condition, float value) {
		return new Term(field, condition, Float.toString(value), TYPE.NUMBER);
	}

	public static Term TERM(String field, String condition, double value) {
		return new Term(field, condition, Double.toString(value), TYPE.NUMBER);
	}


	///////////////////////////////////////////////////////////////////////////
	// BOOLEAN 타입 생성자

	public static Term TERM(String field, String condition, boolean value) {
		return new Term(field, condition, Boolean.toString(value), TYPE.BOOLEAN);
	}

	///////////////////////////////////////////////////////////////////////////
}
