package contrabase.condition;

public abstract class LogicalCondition implements Condition {
	private static final long serialVersionUID = 1L;
	
	final private Condition left, right;
	final private String logical;

	public String getOperator() {
		return logical;
	}
	
	public Condition getLeft() {
		return left;
	}
	
	public Condition getRight() {
		return right;
	}

	public LogicalCondition(Condition left, Condition right, String logical) {
		this.left = left;
		this.right = right;
		this.logical = logical;
	}

	final public String toString() {
		return new StringBuilder()
					.append("(")
					.append(left)
					.append(" ")
					.append(logical)
					.append(" ")
					.append(right)
					.append(")")
					.toString();
	}
}
