package contrabase.condition;

import java.util.SortedSet;
import java.util.TreeSet;

final public class Or extends LogicalCondition {
	private static final long serialVersionUID = 1L;

	Or(Condition left, Condition right) {
		super(left, right, "OR");
	}

	/**
	 * 합집합을 돌려준다.
	 */
	public SortedSet<String> getKeys(KeySelector keySelector) {
		SortedSet<String> keys = new TreeSet<String>();
		
		SortedSet<String> left = getLeft().getKeys(keySelector);
		SortedSet<String> right = getRight().getKeys(keySelector);
		
		// Set 이기 때문에, 모두 추가해도, 중복이 없이 추가된다.
		keys.addAll(left);
		keys.addAll(right);
		
		return keys;
	}
}
