package contrabase.master;

import contrabase.network.ClientSide;
import contrabase.repository.TabletEntries;

/**
 * Repository 에 대한 정보를 담고 있는 클래스.
 */
public class RepositoryEntry {
	private String rid;
	private ClientSide messenger;
	private TabletEntries tablets;

	private String dataIP;
	private int dataPort;

	public RepositoryEntry(String rid, ClientSide messenger, TabletEntries tablets, String dataIP, int dataPort) {
		this.rid = rid;
		this.messenger = messenger;
		this.tablets = tablets;
		this.dataIP = dataIP;
		this.dataPort = dataPort;
	}

	public String getRid() {
		return rid;
	}

	public ClientSide getClientSide() {
		return messenger;
	}

	public TabletEntries getTabletEntries() {
		return tablets;
	}

	public String getDataIp() {
		return dataIP;
	}

	public int getDataPort() {
		return dataPort;
	}
}
