package contrabase.master;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import contrabase.repository.datastore.ContrabaseDatastoreException;

/**
 * 
 * userInform( userId TEXT primary key, password TEXT )
 * User에 대한 정보를 관리하는 클래스 
 * 
 */
public class UserManager {

	private Connection conn = null;
	String uid;
	String pw;
	private String dataDir;

	public UserManager(String dataDir) throws ContrabaseDatastoreException {
		this.dataDir = dataDir;
		open();
	}

	private void open() throws ContrabaseDatastoreException {
		String url = "jdbc:sqlite:" + dataDir + "/master.db";
		try {
			Class.forName("org.sqlite.JDBC");
		} catch (ClassNotFoundException e) {
			throw new ContrabaseDatastoreException(e);
		}
		try {
			conn = DriverManager.getConnection(url);
		} catch (SQLException e) {
			throw new ContrabaseDatastoreException(e);
		}
	}

	public void close() throws ContrabaseDatastoreException {
		try {
			if (conn != null) {
				conn.close();
				conn = null;
			}
		} catch (SQLException e) {
			throw new ContrabaseDatastoreException(e);
		}
	}

	@Override
	public void finalize() {
		try {
			close();
		} catch (ContrabaseDatastoreException e) {
			e.printStackTrace();
		}
	}

	public boolean addUser(String uid, String pw) {
		Statement stat = null;
		boolean result = true;
		try {
			stat = conn.createStatement();
			stat.execute("insert into userInform values('" + uid + "','" + pw + "' )");
			stat.close();
		} catch (SQLException e) {
			result = false;
		} finally {
			try {
				stat.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}

		return result;
	}

	public boolean deleteUser(String uid, String pw) {
		Statement stat = null;
		boolean result = true;
		try {
			stat = conn.createStatement();
			stat.execute("delete from userInform where uid = " + uid);
			stat.close();
		} catch (SQLException e) {
			result = false;
		} finally {
			try {
				stat.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return result;
	}

	public boolean identify(String uid, String pw) {
		
		Statement stat = null;
		ResultSet rs = null;
		String password = null;
		String sql = null;
		boolean result = true;

		try {
			stat = conn.createStatement();
			sql = "select password from userInform where userId = '" + uid + "'";
			rs = stat.executeQuery(sql);

			while (rs.next()) {
				password = rs.getString("password");
			}
			if (password.equals(pw)) {
				result = true;
			} else {
				result = false;
			}
			stat.close();
			rs.close();
		} catch (SQLException e) {
			result = false;
		} finally {
			try {
				stat.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return result;
	}
}
