package contrabase.master.actionhandler;

import java.util.List;
import contrabase.master.MasterSectionDAO;
import contrabase.master.RepositoriesManager;
import contrabase.network.MSG;
import contrabase.network.Message;
import contrabase.repository.datastore.ContrabaseDatastoreException;

/**
 * @author shiva83
 *
 */
public class ActionGetRepositoryList extends ActionHandler {
	private String dataDir;

	public ActionGetRepositoryList(RepositoriesManager manager, String dataDir) {
		super(manager);
		this.dataDir = dataDir;
	}

	@Override
	public void action(Message request, Message response) {
		String userId = (String) request.get(MSG.REQUEST.USER_ID);
		List<String> repositoryList= null;

		MasterSectionDAO section = null;

		// repositoryLis가 empty일 경우 Contrabase에 문제가 있는 상황.  
		try {
			section = new MasterSectionDAO(dataDir, userId);
			
			repositoryList = section.getRepositoryList();
			response.set(MSG.RESPONSE.REPOSITORY_LIST, repositoryList);
			response.setSuccessed();
		} catch (ContrabaseDatastoreException e) {
			e.printStackTrace();
			response.setFailed(e.getMessage());
		} finally {
			try {
				if (section != null)
					section.close();
			} catch (ContrabaseDatastoreException e) {
				e.printStackTrace();
			}
		}
	}
}
