package contrabase.master.actionhandler;

import java.util.*;
import contrabase.master.RepositoriesManager;
import contrabase.network.MSG;
import contrabase.network.MapReduce;
import contrabase.network.Message;

public class ActionGetRepositorySize extends ActionHandler {

	public ActionGetRepositorySize(RepositoriesManager manager) {
		super(manager);
	}

	@Override
	public void action(Message request, Message response) {
		String userId = (String)request.get(MSG.REQUEST.USER_ID);

		// GetRepositorySize 메시지를 생성한다.
		Message msg = new Message();
		msg.set(MSG.REQUEST.USER_ID, userId);
		msg.set(MSG.ACTION, MSG.REQUEST.GET_REPOSITORY_SIZE);
		
		// 연결 요청용 MapReduce 를 생성해서, 요청을 뿌려준다.
		MapReduce mapReduce = new MapReduce(manager.getConnections());

		Message[] responses = null;

		try {
			responses = mapReduce.map(msg);
		} catch (InterruptedException e) {
			e.printStackTrace();
			response.setFailed(e.getMessage());
			return;
		}
		
		Map<String, Long> result = new HashMap<String, Long>();
		
		// 결과를 종합한다.
		for (Message res : responses) {
			String rid = (String)res.get(MSG.RESPONSE.RID);
			long data = (Long)res.get(MSG.RESPONSE.ACTION_DATA);
			
			result.put(rid, data);
		}
		
		// 결과 메시지를 만들어준다. 지운 개수를 담아준다.
		response.setSuccessed();
		response.set(MSG.RESPONSE.ACTION_DATA, result);
	}
}
