package contrabase.master.actionhandler;

import java.util.List;
import contrabase.master.MasterSectionDAO;
import contrabase.master.RepositoriesManager;
import contrabase.network.MSG;
import contrabase.network.Message;
import contrabase.repository.datastore.ContrabaseDatastoreException;

/**
 * @author shiva83
 *
 */
public class ActionGetTableList extends ActionHandler {
	private String dataDir;

	public ActionGetTableList(RepositoriesManager manager, String dataDir) {
		super(manager);
		this.dataDir = dataDir;
	}

	@Override
	public void action(Message request, Message response) {
		String userId = (String) request.get(MSG.REQUEST.USER_ID);
		List<String> tableList= null;

		MasterSectionDAO section = null;

		// tableLis가 empty일 경우 User ID에 해당되는 Table이 하나도 없는 경우  
		try {
			section = new MasterSectionDAO(dataDir, userId);
			
			tableList = section.getTableList();
			response.set(MSG.RESPONSE.TABLE_LIST, tableList);
			response.setSuccessed();
		} catch (ContrabaseDatastoreException e) {
			e.printStackTrace();
			response.setFailed(e.getMessage());
		} finally {
			try {
				if (section != null)
					section.close();
			} catch (ContrabaseDatastoreException e) {
				e.printStackTrace();
			}
		}
	}
}
