package contrabase.master.actionhandler;

import contrabase.master.RepositoriesManager;
import contrabase.network.Message;

public abstract class ActionHandler {
	protected RepositoriesManager manager = null;

	public ActionHandler(RepositoriesManager manager) {
		this.manager = manager;
	}

	public abstract void action(Message request, Message response);

	/**
	 * 실패를 한 개 이상 가지고 있는지 확인한다.
	 * @param responses
	 * @return
	 */
	protected boolean hasFailed(Message[] responses) {
		for (Message m : responses) {
			if (m.isFailed())
				return true;
		}
		return false;
	}
}
