package contrabase.master.actionhandler;

import contrabase.master.LoadBalancer;
import contrabase.master.RepositoriesManager;
import contrabase.network.Message;
import contrabase.repository.datastore.ContrabaseDatastoreException;

public class ActionLoadBalanceAllTables extends ActionHandler {
	private String dataDir;

	public ActionLoadBalanceAllTables(RepositoriesManager manager, String dataDir) {
		super(manager);
		this.dataDir = dataDir;
	}

	@Override
	public void action(Message request, Message response) {
		LoadBalancer balancer = new LoadBalancer(manager, dataDir);
		
		try {
			balancer.loadBalanceAllTables();
			response.setSuccessed();
		} catch (ContrabaseDatastoreException e) {
			e.printStackTrace();
			response.setFailed(e.getLocalizedMessage());
		} catch (InterruptedException e) {
			e.printStackTrace();
			response.setFailed(e.getLocalizedMessage());
		}
	}
}
