package contrabase.master.actionhandler;

import contrabase.master.LoadBalancer;
import contrabase.master.RepositoriesManager;
import contrabase.network.MSG;
import contrabase.network.Message;
import contrabase.repository.datastore.ContrabaseDatastoreException;

public class ActionLoadBalanceTable extends ActionHandler {
	private String dataDir;

	public ActionLoadBalanceTable(RepositoriesManager manager, String dataDir) {
		super(manager);
		this.dataDir = dataDir;
	}

	@Override
	public void action(Message request, Message response) {
		String userId = (String)request.get(MSG.REQUEST.USER_ID);
		String tableName = (String)request.get(MSG.REQUEST.TABLE_NAME);
		
		LoadBalancer balancer = new LoadBalancer(manager, dataDir);
		
		try {
			balancer.loadBalanceTable(userId, tableName);
			response.setSuccessed();
		} catch (ContrabaseDatastoreException e) {
			e.printStackTrace();
			response.setFailed(e.getLocalizedMessage());
		} catch (InterruptedException e) {
			e.printStackTrace();
			response.setFailed(e.getLocalizedMessage());
		}
	}
}
