package contrabase.network;


/**
 * Contrabase 작동시에 사용 되어지는 메시지상수들의 클래스 
 */
public class MSG {
	// 요청 내용
	public static final String ACTION = "ACTION";
	
	/**
	 * Client -> Master -> Repository request 시에 종류를 구분하기 위해서 사용되는 MSG 클래스 
	 */
	public class REQUEST {
		// Key 에 사용되는 것.
		public static final String CONDITION = "REQUEST.CONDITION";
		public static final String VALUE = "REQUEST.VALUE";
		public static final String UPDATE_VALUES = "REQUEST.UPDATE_VALUES";
		
		// action 종류
		public static final String OPEN_CONNECTION = "REQUEST.OPEN_CONNECTION";
		public static final String CLOSE_CONNECTION = "REQUEST.CLOSE_CONNECTION";
		
		public static final String GET_TABLE = "REQUEST.GET_TABLE";
		public static final String GET_TABLE_LIST = "REQUEST.GET_TABLE_LIST";
		public static final String CREATE_TABLE = "REQUEST.CREAT_TABLE";
		public static final String DELETE_TABLE = "REQUEST.DELETE_TABLE";
		public static final String GET_REPOSITORY_LIST = "REQUEST.GET_REPOSITORY_LIST";
		public static final String GET_REPOSITORY_SIZE = "REQUEST.GET_REPOSITORY_SIZE";
		public static final String GET_REPOSITORY_MEMORY = "REQUEST.GET_REPOSITORY_MEMORY";
		public static final String LOAD_BALANCE_TABLE = "REQUEST.LOAD_BALANCE_TABLE";
		public static final String LOAD_BALANCE_ALL_TABLES = "REQUEST.LOAD_BALANCE_ALL_TABLES";
		
		public static final String INSERT = "REQUEST.INSERT";
		public static final String UPDATE = "REQUEST.UPDATE";
		public static final String SELECT = "REQUEST.SELECT";
		public static final String DELETE = "REQUEST.DELETE";
		
		// field 에서 사용하는 항목들
		public static final String TABLE_NAME = "REQUEST.TABLE_NAME";
		public static final String USER_ID = "REQUEST.USER_ID";
		public static final String RID = "REQUEST.RID";
		
		// 필드명
		public static final String SELECTION_ID = "REQUEST.SELECTION_ID";
		public static final String COUNT = "REQUEST.COUNT";
		
		// 값
		public static final String INSERT_DATA = "REQUEST.INSERT_DATA";
	}
	
	/**
	 * Repository -> Master -> Client API에서 요청한 작업을 처리하여 response 에서 구분하기 위한  MSG클래스  
	 */
	public class RESPONSE {
		// Key 에 사용되는 것.
		public static final String RESULT = "RESPONSE.RESULT";
		public static final String ERROR_MESSAGE = "RESPONSE.ERROR_MESSAGE";
		
		public static final String HAS_SELECTION_DATA = "RESPONSE.HAS_SELECTION_DATA";
		public static final String REPOSITORY_IP = "RESPONSE.REPOSITORY_IP";
		public static final String REPOSITORY_PORT = "RESPONSE.REPOSITORY_PORT";
		public static final String REPOSITORY_CHANNEL = "RESPONSE.REPOSITORY_CHANNEL";
		
		public static final String COUNT = "RESPONSE.COUNT";
		
		// result 종류
		public static final String SUCCESSED = "RESPONSE.SUCCESSED";
		public static final String FAILED = "RESPONSE.FAILED";
		
		// Repositories 정보를 담는 필드
		public static final String REPOSITORIES = "RESPONSE.REPOSITORIES";
		public static final String RID = "RESPONSE.REPOSITORY_ID";
		
		// Monitoring Tool에서 사용하는 필드
		public static final String TABLE_LIST = "RESPONSE.TABLE_LIST";
		public static final String REPOSITORY_LIST = "RESPONSE.REPOSITORY_LIST";
		public static final String ACTION_DATA = "RESPONSE.ACTION_DATA";
		
		// 로드 밸런싱에서 사용하는 필드
		public static final String KEY_LIST = "RESPONSE.KEY_LIST";
	}
	
	/**
	 * API -> Repository 요청시에 사용되어지는 MSG 클래스  
	 */
	public class API_TO_REPOSITORY {
		// 필드명
		public static final String GET_DATA = "API_TO_REPOSITORY.GET_DATA";
		public static final String COUNT = "API_TO_REPOSITORY.COUNT";
		public static final String CHANNEL = "API_TO_REPOSITORY.CHANNEL";
	}
	
	/**
	 * Repository -> API  API가 요청한 작업을 처리하고 그 결과를 구분기 위해 사용되어지는 MSG클래스  
	 */
	public class REPOSITORY_TO_API {
		public static final String DATA = "REPOSITORY_TO_API.DATA";
	}
	
	/**
	 * Client <-> Master 간의 통신에서 사용되어지는 MSG 클래스  
	 */
	public class CONNECTION {
		public static final String CLIENT_ID = "CONNECTION.CLIENT_ID";
		public static final String USERNAME = "CONNECTION.USERNAME";
		public static final String PASSWORD = "CONNECTION.PASSWORD";
	}
	
	/**
	 * Master <-> Repository 간의 통신에서 사용되어지는 MSG 클래스  
	 */
	public class MANAGEMENT {
		public static final String REPOSITORY_IP = "MANAGEMENT.REPOSITORY_IP";
		public static final String REPOSITORY_PORT = "MANAGEMENT.REPOSITORY_PORT";
		public static final String REPOSITORY_RID = "MANAGEMENT.REPOSITORY_RID";
		public static final String REPOSITORY_NO = "MANAGEMENT.REPOSITORY_NO";
		
		public static final String REPOSITORY_DATA_IP = "MSG.MANAGEMENT.REPOSITORY_DATA_IP";
		public static final String REPOSITORY_DATA_PORT = "MSG.MANAGEMENT.REPOSITORY_DATA_PORT";
		
		public static final String CONNECTION_INIT = "MANAGEMENT.CONNECTION_INIT";
		public static final String TABLET_ENTRIES = "MANAGEMENT.TABLET_ENTRIES";
		
		public static final String LOAD_BALANCE_ACTION = "MSG.MANAGEMENT.LOAD_BALANCE_ACTION";
		public static final String LOAD_BALANCE_DATA = "MSG.MANAGEMENT.LOAD_BALANCE_DATA";
		public static final String GET_KEYS = "MSG.MANAGEMENT.GET_KEYS";
		public static final String REPOSITORY_ADDRESSES = "MSG.MANAGEMENT.REPOSITORY_ADDRESSES";
	}
}
