package contrabase.network;

/**
 * 쓰레드를 이용하여 연결되어진 repository 에서만 데이터를 가지고 오는 클래스   
 * */
public class MapReduceThread extends Thread {
	private ClientSide connection;
	private int count;
	private Message request;
	private Message[] responses;
	private MapReduce mapReduce;

	public MapReduceThread(ClientSide connection, Message request, Message[] responses, int count, MapReduce mapReduce) {
		this.connection = connection;
		this.request = request;
		this.responses = responses;
		this.count = count;
		this.mapReduce = mapReduce;
	}

	public void run() {
		try {
			responses[count] = connection.send(request);
		} catch (ContrabaseNetworkException e) {
			responses[count] = null;
		}
		
		mapReduce.reduce();
	}
}
