package contrabase.repository;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import contrabase.repository.datastore.TabletEntry;

public class TabletEntries implements Serializable {
	private static final long serialVersionUID = 1L;
	
	Map<String, TabletEntry> tablets = new HashMap<String, TabletEntry>();

	public void put(TabletEntry tabletEntry) {
		tablets.put(
			generateKey(
				tabletEntry.getUserId(),
				tabletEntry.getTabletName()
			),
			tabletEntry
		);
	}

	public TabletEntry get(String userId, String tabletName) {
		return tablets.get(generateKey(userId, tabletName));
	}

	public TabletEntry remove(String userId, String tabletName) {
		return tablets.remove(generateKey(userId, tabletName));
	}

	private String generateKey(String userId, String tabletName) {
		return userId + "/" + tabletName;
	}

	public int size() {
		return tablets.size();
	}
}
