package contrabase.repository.datastore;

import java.util.List;

import contrabase.ObjectContainer;
import contrabase.api.UpdateValue;
import contrabase.condition.Condition;
import contrabase.repository.datastore.sqlite.SelectIterator;

public interface Tablet {
	public void open() throws ContrabaseDatastoreException;
	public void close() throws ContrabaseDatastoreException;
	
	public void insert(ObjectContainer value) throws ContrabaseDatastoreException;
	public int update(List<UpdateValue> values, Condition condition) throws ContrabaseDatastoreException;
	public int delete(Condition condition) throws ContrabaseDatastoreException;
	public SelectIterator select(Condition condition) throws ContrabaseDatastoreException;
	public List<String> getAllKeys() throws ContrabaseDatastoreException;
}
