package contrabase.util;

import java.io.Serializable;

public class Pair<L, R> implements Serializable {
	private static final long serialVersionUID = 1L;
	private final L left;
	private final R right;
	
	public L getLeft() {
		return left;
	}
	
	public R getRight() {
		return right;
	}
	
	public Pair(final L left, final R right) {
		this.left = left;
		this.right = right;
	}
	
	//@SuppressWarnings("unchecked")
	@Override
	public final boolean equals(Object o) {
		if (!(o instanceof Pair))
			return false;
		
		final Pair<?, ?> other = (Pair<?, ?>) o;
		return equal(getLeft(), other.getLeft()) && equal(getRight(), other.getRight());
	}
    
	public static final boolean equal(Object o1, Object o2) {
		return (o1 == null) ? (o2 == null) : o1.equals(o2);
	}
	
	@Override
	public int hashCode() {
		int hLeft = getLeft() == null ? 0 : getLeft().hashCode();
		int hRight = getRight() == null ? 0 : getRight().hashCode();
		
		return hLeft + (57 * hRight);
	}
}
